package com.spring.series.core;

import org.springframework.beans.factory.BeanFactory;
import org.springframework.beans.factory.xml.XmlBeanFactory;
import org.springframework.context.ApplicationContext;
import org.springframework.context.support.ClassPathXmlApplicationContext;
import org.springframework.core.io.ClassPathResource;
import org.springframework.core.io.Resource;

public class TestEmployee {

	public static void main(String[] args) {
		testBeanFactory();
		testApplicationContext();
	}

	private static void testBeanFactory(){
		/**
		 * deprecated as of spring 3.1
		 * http://docs.spring.io/spring/docs/4.0.0.RELEASE/javadoc-api/org/springframework/beans/factory/xml/XmlBeanFactory.html
		 */
		Resource resource = new ClassPathResource("com/spring/series/core/springcontext.xml");
		BeanFactory beanFactory = new XmlBeanFactory(resource);
		Employee employee = (Employee) beanFactory.getBean("employee");

		System.out.println("Spring Application Demo using BeanFactory\n");

		// invoke print() method of Employee class
		employee.printEmployeeDetail();
	}

	private static void testApplicationContext(){

		ApplicationContext applicationContext = new ClassPathXmlApplicationContext("com/spring/series/core/SpringContext.xml");
		Employee employee = (Employee) applicationContext.getBean("employee");

		System.out.println("Spring Application Demo using ApplicationContext\n");

		// invoke print() method of Employee class
		employee.printEmployeeDetail();
	}
}